;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Missile Bill shooter
;
;Uses first extra bit: YES
;Clear	: unlimited turn
;Set	: single turn
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

MISSILE_BILL_NUM	= $01

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; sprite code JSL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
			dcb "INIT"
			dcb "MAIN"
			PHB
			PHK
			PLB
			JSR SPRITE_CODE_START
			PLB
			RTL  

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; main bullet bill shooter code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

RETURN2			RTS
SPRITE_CODE_START	LDA $17AB,x
			BNE RETURN2
			LDA #$60
			STA $17AB,x
			LDA $178B,x
			CMP $1C
			LDA $1793,x
			SBC $1D
			BNE RETURN2
			LDA $179B,x
			CMP $1A
			LDA $17A3,x
			SBC $1B
			BNE RETURN2
			LDA $179B,x
			SEC
			SBC $1A
			CLC
			ADC #$10
			CMP #$10
			BCC RETURN2
			LDA $94
			SEC
			SBC $179B,x
			CLC
			ADC #$11
			CMP #$22
			BCC RETURN2

			JSL $82A9DE
			BMI RETURN2

GENERATE_SPRITE		LDA #$09
			STA $1DFC
			LDA #$01
			STA $14C8,y
			LDA $179B,x
			STA $00E4,y
			LDA $17A3,x
			STA $14E0,y
			LDA $178B,x
			SEC
			SBC #$01
			STA $00D8,y
			LDA $1793,x
			SBC #$00
			STA $14D4,y
			PHX
			TYX
			LDA #MISSILE_BILL_NUM
			STA $7FAB9E,x
			JSL $87F7D2
			JSL $8187A7
			PLX

			LDA $1783,x
			AND #$40
			BEQ NOT_EXTRA
			LDA #$04

NOT_EXTRA		ORA #$08
			PHX
			TYX
			STA $7FAB10,x
			STZ $00
			LDA $94
			CMP $E4,x
			LDA $95
			SBC $14E0,x
			BPL CODE_END
			INC $00
CODE_END		PLX

			JSR SUB_SMOKE2

RETURN			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; display smoke effect for diagonal shooter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

X_OFFSET		dcb $04,$FC

SUB_SMOKE2		LDY #$03
FINDFREE		LDA $17C0,y
			BEQ FOUNDONE
			DEY
			BPL FINDFREE
			RTS

FOUNDONE		LDA #$01
			STA $17C0,y
			LDA $178B,x
			STA $17C4,y

			LDA #$1B
			STA $17CC,y
			LDA $179B,x
			PHX
			LDX $00
			CLC
			ADC X_OFFSET,x
			STA $17C8,y
			PLX
			RTS