;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Para beetle, from SMB3
;
;Extra Bit: YES
;Clear	:has red palette
;Set	:has green palette and is faster than red one
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			incsrc definition.asm

TileMap			db $A0,$A2

Property		db $49,$09,$4B,$0B
Xspeed			db $0C,$F4,$14,$EC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; INIT and MAIN JSL targets
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

			db "INIT"
			LDA $94
			CMP $E4,x
			LDA $95
			SBC $14E0,x
			BPL InitReturn
			INC $157C,x
InitReturn		RTL

			db "MAIN"
			PHB
			PHK
			PLB
			JSR SpriteMain
			PLB
			RTL


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; SPRITE_ROUTINE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteMain		JSR SpriteGraphic

			LDA $9D
			BNE Return
			LDA $14C8,x
			CMP #$08
			BNE Return
			INC $1570,x

			LDA $7FAB10,x
			AND #$04
			LSR A
			ORA $157C,x
			TAY
			LDA Xspeed,y
			STA $B6,x

			LDA $1504,x
			BNE Update
			LDA #$01
			LDY $AA,x
			BEQ Update
			BMI Yspeed000
			DEC A
			DEC A
Yspeed000		CLC
			ADC $AA,x
			STA $AA,x

Update			JSL $81801A
			JSL $818022
			LDA $1491
			STA $1528,x

			LDY #$B9
			LDA $1490
			BEQ StoreTo167A
			LDY #$39
StoreTo167A		TYA	
			STA $167A,x
			JSL $81803A
			BCC Return2
			LDA $14C8,x
			CMP #$08
			BNE Return
			PHK
			PER.w #$0007
			PEA $8020
			JML $81B45C
Return			RTS

			BCC SpriteWins
			LDA $1504,x
			BNE MarioWins000
			LDA #$01
			STA $1504,x
			LDA #$10
			STA $AA,x
MarioWins000		LDA #$08
			STA $154C,x
			LDA $AA,x
			DEC A
			CMP #$F0
			BMI Return
			STA $AA,x
			RTS
SpriteWins		LDA $154C,x
			BNE Return2
			JSL $80F5B7
Return2			LDA $154C,x
			BNE Return
			STZ $1504,x
			RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Sprite's Graphic
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SpriteGraphic		JSR GetDrawInfo

			PHY
			LDA $7FAB10,x
			AND #$04
			LSR A
			ORA $157C,x
			STA $02
			STA $03
			LDA $1570,x
			LSR A
			LSR A
			LDY $1504,x
			BNE FastAnimation
			LSR A
FastAnimation		AND #$01
			STA $03
			PLY

			PHX
			LDA $00
			STA $0300,y
			LDA $01
			SEC
			SBC #$02
			STA $0301,y
			LDX $03
			LDA TileMap,x
			STA $0302,y
			LDX $02
			LDA Property,x
			ORA $64
			STA $0303,y
			PLX

			LDY #$02
			LDA #$00
			JSL $81B7B3
			RTS